/*
Copyright (C) 1997-2001 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

// QGL.H

#pragma once

#include "versions.h"
#include <windows.h>
#include <d3d9.h>

qboolean R_CreateDirect3D (void);
qboolean R_InitVideo (HWND hWnd);
void R_ShutdownVideo (void);
void R_ResetDevice (vidvars_t *vars);
qboolean R_GetVideoModeInfo (int *width, int *height, int mode);
void R_HandleLostDevice (void);
void R_SetVideoSize (void);

qboolean R_ShouldModeChange (vidvars_t *vars);
void R_ModifyVidCvars (vidvars_t *vars);
void R_UnmodifyVidCvars (vidvars_t *vars);

// global D3D Objects
extern IDirect3D9 *d3d_Object;
extern IDirect3DDevice9 *d3d_Device;
extern D3DCAPS9 d3d_DeviceCaps;
extern IDirect3DQuery9 *d3d_FinishEvent;

void R_Finish (void);

typedef void (*funcptr_t) (void);

/*
// handler template
void Draw_OnCreate (void) {}
void Draw_OnReset (void) {}
void Draw_OnLost (void) {}
void Draw_OnDestroy (void) {}

void Draw_Register (void)
{
	static qboolean registered = false;

	if (!registered)
	{
		R_RegisterHandler (Draw_OnCreate, Draw_OnLost, Draw_OnReset, Draw_OnDestroy);
		registered = true;
	}
}
*/

void R_RegisterHandler (funcptr_t OnCreate, funcptr_t OnLost, funcptr_t OnReset, funcptr_t OnDestroy);

#define SAFE_RELEASE(obj) if (obj) {obj->lpVtbl->Release (obj); obj = NULL;}

